
#include <linux/errno.h>
#include <linux/types.h>

#include <asm/io.h>
#include <asm/segment.h>

#include <linux/dtc2.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

/* ================================================================== */

#if (0)

1Wmmeeff WrrMMrrr ********		X:Y: parallel move
01dd0ddd W1MMMRRR ********	EAX	X: parallel move
01dd0ddd W0aaaaaa ********		X: parallel move
01dd1ddd W1MMMRRR ********	EAX	Y: parallel move
01dd1ddd W0aaaaaa ********		Y: parallel move
0100L0LL W1MMMRRR ********	EAX	L: parallel move
0100L0LL W0aaaaaa ********		L: parallel move
001ddddd iiiiiiii ********		immediate short parallel move
001000ee eeeddddd ********		R<->R parallel move
00100000 010MMRRR ********		addr.reg update parallel move
00100000 00000000 ********		NOP parallel move
0001deff W1MMMRRR ********		R:Y: parallel move class I
0001ffdf W0MMMRRR ********		X:R: parallel move class I
		  1QQQdk11		MACR +-S1,S2,D
		  1QQQdk10		MAC  +-S1,S2,D
		  1QQQdk01		MPYR +-S1,S2,D
		  1QQQdk00		MPY  +-S1,S2,D

		  01JJd110		AND  S,D
		  01JJd011		EOR  S,D
		  01JJd010		OR   S,D

		  0JJJd111		CMPM S1,S2
		  0JJJd101		CMP  S1,S2
		  0JJJd100		SUB  S,D
		  0JJJd001		TFR  S,D
		  0JJJd000		ADD  S,D

		  001Jd101		SBC  S,D
		  001Jd001		ADC  S,D
		  0011d111		ROL  D
		  0011d110		NEG  D
		  0011d011		LSL  D
		  0011d010		ASL  D
		  0010d111		ROR  D
		  0010d110		ABS  D
		  0010d011		LSR  D
		  0010d010		ASR  D
		  0001d111		NOT  D
		  0001d110		SUBL S,D
		  0001d011		CLR  D
		  0001d010		ADDL S,D
		  0001d001		RND  D
		  0000d110		SUBR S,D
		  0000d011		TST  D
		  0000d010		ADDR S,D
		  00000000		MOVE S,D

00001111 CCCCaaaa aaaaaaaa		JScc xxx
00001110 CCCCaaaa aaaaaaaa		Jcc  xxx
00001101 0000aaaa aaaaaaaa		JSR  xxx
00001100 0000aaaa aaaaaaaa		JMP  xxx

00001011 11MMMRRR 1010CCCC	EAX	JScc ea
00001011 11MMMRRR 10000000	EAX	JSR  ea
00001010 11MMMRRR 1010CCCC	EAX	Jcc  ea
00001010 11MMMRRR 10000000	EAX	JMP  ea

00001011 11dddddd 001bbbbb	EAX	JSSET #n,S,xxxx
00001011 10pppppp 1S1bbbbb	EAX	JSSET #n,X|Y:pp,xxxx
00001011 01MMMRRR 1S1bbbbb	EAX	JSSET #n,X|Y:ea,xxxx
00001011 00aaaaaa 1S1bbbbb	EAX	JSSET #n,X|Y:aa,xxxx
00001011 11dddddd 000bbbbb	EAX	JSCLR #n,S,xxxx
00001011 10pppppp 1S0bbbbb	EAX	JSCLR #n,X|Y:pp,xxxx
00001011 01MMMRRR 1S0bbbbb	EAX	JSCLR #n,X|Y:ea,xxxx
00001011 00aaaaaa 1S0bbbbb	EAX	JSCLR #n,X|Y:aa,xxxx
00001011 11dddddd 011bbbbb		BTST  #n,D
00001011 10pppppp 0S1bbbbb		BTST  #n,X|Y:pp
00001011 01MMMRRR 0S1bbbbb	EAX	BTST  #n,X|Y:ea
00001011 00aaaaaa 0S1bbbbb		BTST  #n,X|Y:aa
00001011 11dddddd 010bbbbb		BCHG  #n,D
00001011 10pppppp 0S0bbbbb		BCHG  #n,X|Y:pp
00001011 01MMMRRR 0S0bbbbb	EAX	BCHG  #n,X|Y:ea
00001011 00aaaaaa 0S0bbbbb		BCHG  #n,X|Y:aa

00001010 11dddddd 001bbbbb	EAX	JSET  #n,S,xxxx
00001010 10pppppp 1S1bbbbb	EAX	JSET  #n,X|Y:pp,xxxx
00001010 01MMMRRR 1S1bbbbb	EAX	JSET  #n,X|Y:ea,xxxx
00001010 00aaaaaa 1S1bbbbb	EAX	JSET  #n,X|Y:aa,xxxx
00001010 11dddddd 000bbbbb	EAX	JCLR  #n,S,xxxx
00001010 10pppppp 1S0bbbbb	EAX	JCLR  #n,X|Y:pp,xxxx
00001010 01MMMRRR 1S0bbbbb	EAX	JCLR  #n,X|Y:ea,xxxx
00001010 00aaaaaa 1S0bbbbb	EAX	JCLR  #n,X|Y:aa,xxxx
00001010 11dddddd 011bbbbb		BSET  #n,D
00001010 10pppppp 0S1bbbbb		BSET  #n,X|Y:pp
00001010 01MMMRRR 0S1bbbbb	EAX	BSET  #n,X|Y:ea
00001010 00aaaaaa 0S1bbbbb		BSET  #n,X|Y:aa
00001010 11dddddd 010bbbbb		BCLR  #n,D
00001010 10pppppp 0S0bbbbb		BCLR  #n,X|Y:pp
00001010 01MMMRRR 0S0bbbbb	EAX	BCLR  #n,X|Y:ea
00001010 00aaaaaa 0S0bbbbb		BCLR  #n,X|Y:aa

0000100S W1MMMRRR 1spppppp	EAX	MOVEP (X/Y)
0000100S W1MMMRRR 01pppppp	EAX	MOVEP (X,Y/P)
0000100S W1dddddd 00pppppp		MOVEP (X,Y/S)
0000100d 10MMMRRR ********	EAX	R:Y: parallel move class II
0000100d 00MMMRRR ********	EAX	X:R: parallel move class II

00000111 W1MMMRRR 10dddddd	EAX	MOVEM
00000111 W0aaaaaa 00dddddd		MOVEM

00000110 iiiiiiii 1010hhhh		REP #xxx
00000110 11dddddd 00100000		REP S
00000110 01MMMRRR 0s100000		REP X|Y:ea
00000110 00aaaaaa 0s100000		REP X|Y:aa
00000110 iiiiiiii 1000hhhh	EAX	DO  #xxx,expr
00000110 11DDDDDD 00000000	EAX	DO  S,expr
00000110 01MMMRRR 0S000000	EAX	DO  X|Y:ea,expr
00000110 00aaaaaa 0S000000	EAX	DO  X|Y:aa,expr

00000101 iiiiiiii 101ddddd		MOVEC #xx,D1
00000101 W1MMMRRR 0s1ddddd	EAX	MOVEC
00000101 W0aaaaaa 0s1ddddd		MOVEC

00000100 W1eeeeee 101ddddd		MOVEC
00000100 010MMRRR 0001dddd		LUA  ea,D

00000011 CCCC0ttt 0JJJDTTT		TCC S1,D1 S2,D2

00000010 CCCC0000 0JJJD000		TCC S1,D1

00000001 11011RRR 0001d101		NORM Rn,D
00000001 10000000 01JJd000		DIV  S,D
00000001 000sssss 11QQdk11		MACR +-S,#n,D
00000001 000sssss 11QQdk10		MAC  +-S,#n,D
00000001 000sssss 11QQdk01		MPYR +-S,#n,D
00000001 000sssss 11QQdk00		MPY  +-S,#n,D

00000000 iiiiiiii 111110EE		ORI  #xx,D
00000000 iiiiiiii 101110EE		ANDI #xx,D
00000000 00000000 10001100		ENDDO
00000000 00000000 10000111		STOP
00000000 00000000 10000110		WAIT
00000000 00000000 10000100		RESET
00000000 00000000 00001100		RTS
00000000 00000000 0000101d		DEC
00000000 00000000 0000100d		INC
00000000 00000000 00000110		SWI
00000000 00000000 00000101		ILLEGAL
00000000 00000000 00000100		RTI
00000000 00000011 0000cccc		DEBUGcc
00000000 00000010 00000000		DEBUG
00000000 00000000 00000000		NOP

#endif

/* ================================================================== */

static char DABUF[128];
static int Dp;
static int OpcodeLen;
static u_long CurrAdr,opc2;

static char DESTAB3[] = "a???????b";

static char *DD[] = { "x0","x1","y0","y1","???" };
static char *QQ[] = { "y1","x0","y0","x1" };
static char *JJ[] = { "x0","y0","x1","y1" };

static char *DDD[] = { "a0","b0","a2","b2","a1","b1","a","b","???" };
static char *LLL[] = { "a10","b10","X","Y","a","b","ab","ba","???" };
static char *FFF[] = { "m0","m1","m2","m3","m4","m5","m6","m7","???" };
static char *NNN[] = { "n0","n1","n2","n3","n4","n5","n6","n7","???" };
static char *TTT[] = { "r0","r1","r2","r3","r4","r5","r6","r7","???" };
static char *GGG[] = { "???","sr","omr","sp","ssh","ssl","la","lc","???" };

static char *CCCC[] = { "cc","ge","ne","pl","nn","ec","lc","gt",
			"cs","lt","eq","mi","nr","es","ls","le" };

static char *JJJ1[] = { "ab","ab","X","Y","x0","x1","y0","y1" };

static char *MFF1[] = { "x0","x1","a","b" };
static char *MFF2[] = { "y0","y1","a","b" };

static char *MKK[] = { "mpy","mpyr","mac","macr" };

static char *QQQ[] = { "x0,x0","y0,y0","x1,x0","y1,y0",
		       "x0,y1","y0,x0","x1,y0","y1,x1" };

static char *ABTAB[] = {
	"","","bclr","bset","jclr","jset","jclr","jset",
	"","","bchg","btst","jsclr","jsset","jsclr","jsset" };

/* ================================================================== */


static void Dprintf (char *fmt,...)
{
 va_list ap;
 int n;
  va_start(ap, fmt);
  n=vsprintf(DABUF+Dp,fmt,ap); if (n>0) Dp+=n;
  va_end(ap);
}


/* ================================================================== */


static char *EffAdd(char space,int mr, u_long (*F)(u_short,int))
{
 static char buf[32];
 int n;
 int R=mr&7;

  *buf=0;
  if (space && (mr!=0x34))
    n=sprintf(buf,"%c:",space);
  else n=0;
  switch(mr>>3) {
    case 0:   sprintf(buf+n,"(r%d)-n%d",R,R); break;
    case 1:   sprintf(buf+n,"(r%d)+n%d",R,R); break;
    case 2:   sprintf(buf+n,"(r%d)-",R); break;
    case 3:   sprintf(buf+n,"(r%d)+",R); break;
    case 4:   sprintf(buf+n,"(r%d)",R); break;
    case 5:   sprintf(buf+n,"(r%d+n%d)",R,R); break;
    case 6:   if (R==4) {
		sprintf(buf+n,"#$%06lx",(opc2=F(CurrAdr,1)));
		OpcodeLen=2;
	       }
	      else if (R==0) {
		sprintf(buf+n,">$%04lx",(opc2=F(CurrAdr,1)));
		OpcodeLen=2;
	       }
	      else sprintf(buf+n,"???");
	      break;
    case 7:   sprintf(buf+n,"-(r%d)",R); break;
   }
  return buf;
}


static char *D5enc(int d)
{
  switch(d>>3) {
    case 0: if (d&4) return(DD[d&3]); else return(DD[4]);
    case 1: return(DDD[d&7]);
    case 2: return(TTT[d&7]);
    case 3: return(NNN[d&7]);
   }
  return NULL;
}


static char *D6enc(int d)
{
  if ((d&0x20)==0) return(D5enc(d));
  switch((d>>3)&3) {
    case 0: return(FFF[d&7]);
    case 1: return(DD[4]);
    case 2: return(DD[4]);
    case 3: return(GGG[d&7]);
   }
  return NULL;
}


/* ================================================================== */


static void op_b0(u_long op)
{
 static char *EEf[] = { "mr","ccr","omr","???" };
 char *s;

  if (op==0x200) { Dprintf("debug"); return; }
  if ((op&0xfff0)==0x300) {
    Dprintf("debug%s",CCCC[op&15]); return;
   }
  switch (op&0xf0) {
    case 0x00:  switch(op&15) {
		  case 0:	s="nop"; break;
		  case 4:	s="rti"; break;
		  case 5:	s="illegal"; break;
		  case 6:	s="swi"; break;
		  case 8:	s="inc\ta"; break;
		  case 9:	s="inc\tb"; break;
		  case 10:	s="dec\ta"; break;
		  case 11:	s="dec\tb"; break;
		  case 12:	s="rts"; break;
		  default:	goto ill_b0;
		 }
		break;
    case 0x80:  switch(op&15) {
		  case 4:	s="reset"; break;
		  case 6:	s="wait"; break;
		  case 7:	s="stop"; break;
		  case 12:	s="enddo"; break;
		  default:	goto ill_b0;
		 }
		break;
    case 0xb0:  if ((op&0xc)!=8) goto ill_b0;
		Dprintf("andi\t#$");
		goto aoi_b0;
    case 0xf0:  if ((op&0xc)!=8) goto ill_b0;
		Dprintf("ori\t#$");
aoi_b0:
		s=EEf[op&3];
		Dprintf("%04x,",(op>>8)&0xff);
		Dprintf("%s",s);
		return;
ill_b0:
    default:	s="???";
   }
  Dprintf("%s",s);
}


static void op_b1(u_long op)
{
 char reg;

  reg=(op&8? 'b':'a');
  switch(op&0xe0c0) {
    case 0x00c0: Dprintf("%s",(op&2? "mac":"mpy"));
		 if (op&1) Dprintf("r");
		 Dprintf("\t");
		 if (op&4) Dprintf("-");
		 Dprintf("%s,#%ld,%c",QQ[(op>>4)&3],(op>>8)&0x1f,reg);
		 break;
    case 0x8040: if ((op&0x1807)!=0) goto ill_b1;
		 Dprintf("div\t%s,%c",JJ[(op>>4)&3],reg);
		 break;
    case 0xc000: if ((op&0x1817)!=0x1815) goto ill_b1;
		 Dprintf("norm\tr%ld,%c",(op>>8)&7,reg);
		 break;
ill_b1:
    default:	 Dprintf("???");
   }
}


static void op_b23(u_long op,int is3)
{
 int jjj,d;

  if (is3) {
    if ((op&0x880)!=0) { Dprintf("???"); return; }
   }
  else {
    if ((op&0xf87)!=0) { Dprintf("???"); return; }
   }
  Dprintf("t%s\t",CCCC[(op>>12)&15]);
  jjj=(op>>4)&7; d=op&8;
  if (jjj<2)
    Dprintf("%c,%c",DESTAB3[d^8],DESTAB3[d]);
  else
    Dprintf("%s,%c",JJJ1[jjj],DESTAB3[d]);
  if (is3) {
    Dprintf("\tr%d,r%d",(op>>8)&7,op&7);
   }
}


static void op_b4(u_long op, u_long (*F)(u_short,int))
{
 int mr;

  mr=(op>>8)&0x3f;
  if ((op&0xe0f0)==0x4010) {		/* LUA */
    Dprintf("lua\t%s,%c%d",EffAdd(0,mr&0x1f,F),(op&8? 'n':'r'),op&7);
   }
  else if ((op&0x40e0)==0x40a0) {	/* MOVEC */
    Dprintf("move\t");
    if (op&0x8000) 			/* movec s2,d1 */
      Dprintf("%s,%s",D6enc(mr),D6enc(op&0x3f));
    else 				/* movec s1,d2 */
      Dprintf("%s,%s",D6enc(op&0x3f),D6enc(mr));
   }
  else
    Dprintf("???");
}


static void op_b5(u_long op, u_long (*F)(u_short,int))
{
 int mr;
 char *s;
 char space;

  mr=(op>>8)&0x3f;
  if ((op&0xe0)==0xa0) {
    s=D6enc(op&0x3f);
    Dprintf("move\t#$%02x,",(op>>8)&0xff);
    Dprintf("%s",s);
   }
  else if ((op&0x40a0)==0x20) {
    Dprintf("move\t");
    s=D6enc(op&0x3f);
    space=(op&0x40? 'Y':'X');
    if (op&0x8000)			/* movec x|y:aa,D1 */
      Dprintf("%c:<%02x,%s",space,mr,s);
    else				/* movec S1,x|y:aa */
      Dprintf("%s,%c:<%02x",s,space,mr);
   }
  else if ((op&0x40a0)==0x4020) {
    Dprintf("move\t");
    s=D6enc(op&0x3f);
    space=(op&0x40? 'Y':'X');
    if (op&0x8000)			/* movec x|y:ea,D1 */
      Dprintf("%s,%s",EffAdd(space,mr,F),s);
    else				/* movec S1,x|y:ea */
      Dprintf("%s,%s",s,EffAdd(space,mr,F));
   }
  else
    Dprintf("???");
}


static void op_b6(u_long op, u_long (*F)(u_short,int))
{
 int mr;
 char space;

  mr=(op>>8)&0x3f;
  space=(op&0x40? 'Y':'X');
  if ((op&0xf0)==0xa0) {
    Dprintf("rep\t#%d",((op>>8)&0xff)|((op&15)<<8));
   }
  else if ((op&0xc0ff)==0xc020) {
    Dprintf("rep\t%s",D6enc(mr));
   }
  else if ((op&0xc0bf)==0x4020) {
    Dprintf("rep\t%s",EffAdd(space,mr,F));
   }
  else if ((op&0xc0bf)==0x20) {
    Dprintf("rep\t%c:<$%02x",space,mr);
   }
  else if ((op&0xf0)==0x80) {
    Dprintf("do\t#%d,",((op>>8)&0xff)|((op&15)<<8));
    Dprintf("$%04lx",(opc2=F(CurrAdr,1)));
    OpcodeLen=2;
   }
  else if ((op&0xc0ff)==0xc000) {
    Dprintf("do\t%s,",D6enc(mr));
    Dprintf("$%04lx",(opc2=F(CurrAdr,1)));
    OpcodeLen=2;
   }
  else if ((op&0xc0bf)==0x4000) {
    Dprintf("do\t%s,",EffAdd(space,mr,F));
    Dprintf("$%04lx",(opc2=F(CurrAdr,1)));
    OpcodeLen=2;
   }
  else if ((op&0xc0bf)==0) {
    Dprintf("do\t%c:<$%02x,",space,mr);
    Dprintf("$%04lx",(opc2=F(CurrAdr,1)));
    OpcodeLen=2;
   }
  else
    Dprintf("???");
}


static void op_b7(u_long op, u_long (*F)(u_short,int))
{
 int mr;
 char *s;

  mr=(op>>8)&0x3f;
  Dprintf("movem\t");
  s=D6enc(op&0x3f);
  if ((op&0x40c0)==0) {
    if (op&0x8000)			/* movec p:aa,D1 */
      Dprintf("P:<%02x,%s",mr,s);
    else				/* movec S1,p:aa */
      Dprintf("%s,P:<%02x",s,mr);
   }
  else if ((op&0x40c0)==0x4080) {
    if (op&0x8000)			/* movec p:ea,D1 */
      Dprintf("%s,%s",EffAdd('P',mr,F),s);
    else				/* movec S1,p:ea */
      Dprintf("%s,%s",s,EffAdd('P',mr,F));
   }
  else
    Dprintf("???");
}


/* ================================================================== */


static void op_bab(u_long op, u_long (*F)(u_short,int))
{
 char *s;
 int op0b,x,y,d,o2;
 u_long v;

  op0b=((op&0x10000l)!=0);
  d=(op>>8)&0x3f;

  if ((op&0xc0d0)==0xc080) {
    if (op&0x20) {
      Dprintf("%s",(op0b? "js":"j"));
      Dprintf("%s \t",CCCC[(op>>12)&15]); o2=1;
     }
    else {
      if ((op&15)==0)
	Dprintf("%s\t",(op0b? "jsr":"jmp"));
      else Dprintf("???");
      Dprintf("%s",EffAdd(0,d,F)); o2=0;
     }
   }
  else {
    x=(op>>5)&7; y=(op>>14)&3;
    switch (x) {
      case 0:  if (y==3) s=(op0b? "jsclr":"jclr");
		 else s=(op0b? "bchg":"bclr");
	       break;
      case 1:  if (y==3) s=(op0b? "jsset":"jset");
		 else s=(op0b? "btst":"bset");
	       break;
      default: s=ABTAB[x|(op0b<<3)]; break;
     }
    o2 = (*s=='j');
    Dprintf("%s\t#%d,",s,(op&0x1f));
    switch(y) {
      case 0: Dprintf("%c:<$%02x",(op&0x40? 'Y':'X'),d);
	      break;
      case 1: Dprintf("%s",EffAdd((op&0x40? 'Y':'X'),d,F));
	      break;
      case 2: Dprintf("%c:<<$ff%02x",(op&0x40? 'y':'x'),d|0xc0);
	      break;
      case 3: Dprintf("%s",D6enc(d));
	      break;
     }
    if (o2) Dprintf(",");
   }
  if (o2) {
    Dprintf("$%04lx",(opc2=F(CurrAdr,1)));
    OpcodeLen=2;
   }
}


static void op_bcf(u_long op)
{
  switch((op>>16)&3) {
    case 0:	Dprintf("jmp\t<$%x",op&0xfff);
		break;
    case 1:	Dprintf("jsr\t<$%x",op&0xfff);
		break;
    case 2:	Dprintf("j%s\t<$%x",CCCC[(op>>12)&15],op&0xfff);
		break;
    default:	Dprintf("js%s\t<$%x",CCCC[(op>>12)&15],op&0xfff);
		break;
   }
}


/* ================================================================== */

static char *KKK0[] = { "move","tfr","addr","tst","???","cmp","subr","cmpm" };
static char  lKK0[] = { 1,1,1,0,0,1,1,1 };
static char *KKK1[] = { "add","rnd","addl","clr","sub","???","subl","not" };
static char  lKK1[] = { 1,0,1,0,1,0,1,0 };
static char *KKK2[] = { "add","adc","asr","lsr","sub","sbc","abs","ror" };
static char *KKK3[] = { "add","adc","asl","lsl","sub","sbc","neg","rol" };
static char  lKK2[] = { 1,1,0,0,1,1,0,0 };
static char *KKK4[] = { "add","tfr","or","eor","sub","cmp","and","cmpm" };

static void parmovOp(u_long op)
{
 int jjj,kkk,lll;
 int ac1,ac2;

  jjj=(op>>4)&15; kkk=op&7;
  ac1=(op&8? 'b':'a');		/* dest */
  ac2=(op&8? 'a':'b');		/* the other */
  switch(jjj) {
    case 0:     if (kkk==0)
		  Dprintf("move");
		else {
		  if (lKK0[kkk])
		    Dprintf("%s\t%c,%c",KKK0[kkk],ac2,ac1);
		  else
		    Dprintf("%s\t%c",KKK0[kkk],ac1);
		 }
		break;
    case 1:	if (lKK1[kkk])
		  Dprintf("%s\t%c,%c",KKK1[kkk],ac2,ac1);
		else
		  Dprintf("%s\t%c",KKK1[kkk],ac1);
		break;
    case 2:	if (lKK2[kkk])
		  Dprintf("%s\t%s,%c",KKK2[kkk],JJJ1[jjj],ac1);
		else
		  Dprintf("%s\t%c",KKK2[kkk],ac1);
		break;
    case 3:	if (lKK2[kkk])
		  Dprintf("%s\t%s,%c",KKK3[kkk],JJJ1[jjj],ac1);
		else
		  Dprintf("%s\t%c",KKK3[kkk],ac1);
		break;
    case 4: case 5: case 6: case 7:
		Dprintf("%s\t%s,%c",KKK4[kkk],JJJ1[jjj],ac1);
		break;
    default:	Dprintf("%s\t",MKK[kkk&3]);
		if (kkk&4) Dprintf("-");
		Dprintf("%s,%c",QQQ[jjj&7],ac1);
		break;
   }
}


static void parmove1(u_long op, u_long (*F)(u_short,int))
{
 int mr,pp;
 char space,space2;

  mr=(op>>8)&0x3f;
  if ((op&0x4000)==0) {
    parmovOp(op);
    if (op&0x8000) {		/* R:Y: */
      if (op&0x10000l)
	Dprintf("\ty0,b\tb,%s",EffAdd('Y',mr,F));
      else
	Dprintf("\ty0,a\ta,%s",EffAdd('Y',mr,F));
     }
    else {			/* X:R: */
      if (op&0x10000l)
	Dprintf("\tb,%s\tx0,b",EffAdd('X',mr,F));
      else
	Dprintf("\ta,%s\tx0,a",EffAdd('X',mr,F));
     }
   }
  else {
    pp=op&0x3f;
    space=(op&0x10000l? 'Y':'X');
    Dprintf("movep\t");
    switch (op&0xc0) {
      case 0x00: if (op&0x8000)
		   Dprintf("%s,%c:<<$ff%02x",D6enc(mr),space,pp|0xc0);
		 else
		   Dprintf("%c:<<$ff%02x,%s",space,pp|0xc0,D6enc(mr));
		 break;
      case 0x40: if (op&0x8000)
		   Dprintf("%s,%c:<<$ff%02x",EffAdd('P',mr,F),space,pp|0xc0);
		 else
		   Dprintf("%c:<<$ff%02x,%s",space,pp|0xc0,EffAdd('P',mr,F));
		 break;
      default:	 space2=(op&0x40? 'Y':'X');
		 if (op&0x8000)
		   Dprintf("%s,%c:<<$ff%02x",EffAdd(space2,mr,F),space,pp|0xc0);
		 else
		   Dprintf("%c:<<$ff%02x,%s",space,pp|0xc0,EffAdd(space2,mr,F));
		 break;
     }
   }
}


static void parmove2(u_long op, u_long (*F)(u_short,int))
{
 int pa1,mr,mry,ee;
 u_long lll;
 char space;

  parmovOp(op);

  pa1=(op>>20)&15;
  mr=(op>>8)&0x3f;
  switch (pa1) {
    case 1:	if (op&0x4000) {	/* R:Y: */
		  Dprintf("\t%c,",(op&0x80000? 'b':'a'));
		  Dprintf("%s\t",(op&0x40000? "x1":"x0"));
		  if (op&0x8000) {	/* Y:ea->D1 */
		    Dprintf("%s,",EffAdd('Y',mr,F));
		    Dprintf("%s",MFF2[(op>>16)&3]);
		   }
		  else {		/* S1->Y:ea */
		    Dprintf("%s,",MFF2[(op>>16)&3]);
		    Dprintf("%s",EffAdd('Y',mr,F));
		   }
		 }
		else {			/* X:R: */
		  if (op&0x8000) {	/* X:ea->D1 */
		    Dprintf("\t%s,",EffAdd('X',mr,F));
		    Dprintf("%s\t",MFF1[(op>>18)&3]);
		   }
		  else {		/* S1->X:ea */
		    Dprintf("\t%s,",MFF1[(op>>18)&3]);
		    Dprintf("%s\t",EffAdd('X',mr,F));
		   }
		  Dprintf("%c,",(op&0x20000? 'b':'a'));
		  Dprintf("%s",(op&0x10000? "y1":"y0"));
		 }
		break;
    case 2: case 3:
		if ((op&0x1fff00l)==0) break;	/* NOP */
		if ((op&0x1fe000l)==0x4000) {	/* upd */
		  Dprintf("\t%s",EffAdd(0,mr&0x1f,F));
		 }
		else if ((op&0x1c0000l)==0) {	/* R<->R */
		  Dprintf("\t%s,",D5enc((op>>13)&0x1f));
		  Dprintf("%s",D5enc((op>>8)&0x1f));
		 }
		else {				/* imm */
		  Dprintf("\t#$%02x,",(op>>8)&0xff);
		  Dprintf("%s",D5enc((op>>16)&0x1f));
		 }
		break;
    case 4: case 5: case 6: case 7:
		if ((op&0x340000l)==0) {
		  lll=(op>>16)&15; if (lll&8) lll|=4; lll&=7;
		  if (op&0x4000) {
		    if (op&0x8000) 		/* L:ea->D */
		      Dprintf("\t%s,%s",EffAdd('L',mr,F),LLL[lll]);
		    else 			/* S->L:ea */
		      Dprintf("\t%s,%s",LLL[lll],EffAdd('L',mr,F));
		   }
		  else {
		    if (op&0x8000) 		/* L:ea->D */
		      Dprintf("\tL:<$%02x,%s",mr,LLL[lll]);
		    else 			/* S->L:ea */
		      Dprintf("\t%s,L:<$%02x",LLL[lll],mr);
		   }
		 }
		else {
		  lll=(op>>16)&0x3f; lll=((lll>>1)&0x18)|(lll&7);
		  space=(op&0x80000l? 'Y':'X');
		  if (op&0x4000) {
		    if (op&0x8000) 		/* x|y:ea->D */
		      Dprintf("\t%s,%s",EffAdd(space,mr,F),D5enc(lll));
		    else			/* S->x|y:ea */
		      Dprintf("\t%s,%s",D5enc(lll),EffAdd(space,mr,F));
		   }
		  else {
		    if (op&0x8000) 		/* x|y:ea->D */
		      Dprintf("\t%c:<$%02x,%s",space,mr,D5enc(lll));
		    else			/* S->x|y:ea */
		      Dprintf("\t%s,%c:<$%02x",D5enc(lll),space,mr);
		   }
		 }
		break;
    default:	mr&=0x1f;
		lll = ((op>>13)&3) | ((mr^4)&4);
		mry = ((op>>17)&0x18) | lll;
		ee = (op>>18)&3;
		if (op&0x400000l)
		  Dprintf("\t%s,%s",EffAdd('X',mr,F),MFF1[ee]);
		else
		  Dprintf("\t%s,%s",MFF1[ee],EffAdd('X',mr,F));
		ee = (op>>16)&3;
		if (op&0x8000)
		  Dprintf("\t%s,%s",EffAdd('Y',mry,F),MFF2[ee]);
		else
		  Dprintf("\t%s,%s",MFF2[ee],EffAdd('Y',mry,F));
		break;
   }
}


/* ================================================================== */


int disasm56 (u_short a, u_long (*F)(u_short,int), FILE *fd)
{
 u_long op;

  *DABUF=0; Dp=0;
  CurrAdr=a;

  fprintf(fd,"%04X: ",a);
  op=F(CurrAdr,0); OpcodeLen=1;
  fprintf(fd,"%06lX",op);

  switch((op>>16)&0xff) {
    case 0:	op_b0(op);
		break;
    case 1:	op_b1(op);
		break;
    case 2:	op_b23(op,0);
		break;
    case 3:	op_b23(op,1);
		break;
    case 4:	op_b4(op,F);
		break;
    case 5:	op_b5(op,F);
		break;
    case 6:	op_b6(op,F);
		break;
    case 7:	op_b7(op,F);
		break;
    case 8: case 9:
		parmove1(op,F); break;
    case 10:
    case 11:	op_bab(op,F);
		break;
    case 12: case 13: case 14: case 15:
		op_bcf(op);
		break;
    default:	parmove2(op,F);
   }

  if (OpcodeLen==2) fprintf(fd," %06lx\t",opc2);
    else fprintf(fd,"\t\t");
  fprintf(fd,"%s\n",DABUF);
  return(OpcodeLen);
}

