
	opt	cex,nocl,nocm,nomd,mex,nou,xr

; ===============================================================
;
;	DTC2 DSP (56002) - by Harawi 3/95
;
; ===============================================================
;
		nolist

; hardware constants
;
OPMODE		equ	$80		; modo operazioni DSP
;
INT_MINX	equ	0
INT_MAXX	equ	$100
EXT_MINX	equ	$200
EXT_MAXX	equ	$c000
;
INT_MINY	equ	0
INT_MAXY	equ	$100
EXT_MINY	equ	$200
EXT_MAXY	equ	$c000
;
INT_MINP	equ	0
INT_PGMP	equ	$40
INT_MAXP	equ	$200
EXT_MINP	equ	$200
EXT_MAXP	equ	$c000
;
	nolist
; ===============================================================
;
; 56001 constants
;
;	EQUATES for I/O Port Programming
;
;------------------------------------------------------------------------

;	Register Addresses

M_BCR	EQU	$FFFE		; Port A Bus Control Register
M_PBC	EQU	$FFE0		; Port B Control Register
M_PBDDR	EQU	$FFE2		; Port B Data Direction Register
M_PBD	EQU	$FFE4		; Port B Data Register
M_PCC	EQU	$FFE1		; Port C Control Register
M_PCDDR	EQU	$FFE3		; Port C Data Direction Register
M_PCD	EQU	$FFE5		; Port C Data Register

;------------------------------------------------------------------------
;
;	EQUATES for Host Interface
;
;------------------------------------------------------------------------

;	Register Addresses

M_HCR	EQU	$FFE8		; Host Control Register
M_HSR	EQU	$FFE9		; Host Status Register
M_HRX	EQU	$FFEB		; Host Receive Data Register
M_HTX	EQU	$FFEB		; Host Transmit Data Register

;	Host Control Register Bit Flags

M_HRIE	EQU	0		; Host Receive Interrupt Enable
M_HTIE	EQU	1		; Host Transmit Interrupt Enable
M_HCIE	EQU	2		; Host Command Interrupt Enable
M_HF2	EQU	3		; Host Flag 2
M_HF3	EQU	4		; Host Flag 3

;	Host Status Register Bit Flags

M_HRDF	EQU	0		; Host Receive Data Full
M_HTDE	EQU	1		; Host Transmit Data Empty
M_HCP	EQU	2		; Host Command Pending
M_HF	EQU	$18		; Host Flag Mask
M_HF0	EQU	3		; Host Flag 0
M_HF1	EQU	4		; Host Flag 1
M_DMA	EQU	7		; DMA Status

;------------------------------------------------------------------------
;
;	EQUATES for Serial Communications Interface (SCI)
;
;------------------------------------------------------------------------

;	Register Addresses

M_SRXL	EQU	$FFF4		; SCI Receive Data Register (low)
M_SRXM	EQU	$FFF5		; SCI Receive Data Register (middle)
M_SRXH	EQU	$FFF6		; SCI Receive Data Register (high)
M_STXL	EQU	$FFF4		; SCI Transmit Data Register (low)
M_STXM	EQU	$FFF5		; SCI Transmit Data Register (middle)
M_STXH	EQU	$FFF6		; SCI Transmit Data Register (high)
M_STXA	EQU	$FFF3		; SCI Transmit Data Address Register
M_SCR	EQU	$FFF0		; SCI Control Register
M_SSR	EQU	$FFF1		; SCI Status Register
M_SCCR	EQU	$FFF2		; SCI Clock Control Register

;	SCI Control Register Bit Flags

M_WDS	EQU	$3		; Word Select Mask
M_WDS0	EQU	0		; Word Select 0
M_WDS1	EQU	1		; Word Select 1
M_WDS2	EQU	2		; Word Select 2
M_SBK	EQU	4		; Send Break
M_WAKE	EQU	5		; Wake-up Mode Select
M_RWI	EQU	6		; Receiver Wake-up Enable
M_WOMS	EQU	7		; Wired-OR Mode Select
M_RE	EQU	8		; Receiver Enable
M_TE	EQU	9		; Transmitter Enable
M_ILIE	EQU	10		; Idle Line Interrupt Enable
M_RIE	EQU	11		; Receive Interrupt Enable
M_TIE	EQU	12		; Transmit Interrupt Enable
M_TMIE	EQU	13		; Timer Interrupt Enable

;	SCI Status Register Bit Flags

M_TRNE	EQU	0		; Transmitter Empty
M_TDRE	EQU	1		; Transmit Data Register Empty
M_RDRF	EQU	2		; Receive Data Register Full
M_IDLE	EQU	3		; Idle Line
M_OR	EQU	4		; Overrun Error
M_PE	EQU	5		; Parity Error
M_FE	EQU	6		; Framing Error
M_R8	EQU	7		; Received Bit 8

;	SCI Clock Control Register Bit Flags

M_CD	EQU	$FFF		; Clock Divider Mask
M_COD	EQU	12		; Clock Out Divider
M_SCP	EQU	13		; Clock Prescaler
M_RCM	EQU	14		; Receive Clock Source
M_TCM	EQU	15		; Transmit Clock Source

;------------------------------------------------------------------------
;
;	EQUATES for Synchronous Serial Interface (SSI)
;
;------------------------------------------------------------------------

;	Register Addresses

M_RX	EQU	$FFEF		; Serial Receive Data Register
M_TX	EQU	$FFEF		; Serial Transmit Data Register
M_CRA	EQU	$FFEC		; SSI Control Register A
M_CRB	EQU	$FFED		; SSI Control Register B
M_SR	EQU	$FFEE		; SSI Status Register
M_TSR	EQU	$FFEE		; SSI Time Slot Register

;	SSI Control Register A Bit Flags

M_PM	EQU	$FF		; Prescale Modulus Select Mask
M_DC	EQU	$1F00		; Frame Rate Divider Control Mask
M_WL	EQU	$6000		; Word Length Control Mask
M_WL0	EQU	13		; Word Length Control 0
M_WL1	EQU	14		; Word Length Control 1
M_PSR	EQU	15		; Prescaler Range

;	SSI Control Register B Bit Flags

M_OF	EQU	$3		; Serial Output Flag Mask
M_OF0	EQU	0		; Serial Output Flag 0
M_OF1	EQU	1		; Serial Output Flag 1
M_SCD	EQU	$1C		; Serial Control Direction Mask
M_SCD0	EQU	2		; Serial Control 0 Direction
M_SCD1	EQU	3		; Serial Control 1 Direction
M_SCD2	EQU	4		; Serial Control 2 Direction
M_SCKD	EQU	5		; Clock Source Direction
M_FSL	EQU	8		; Frame Sync Length
M_SYN	EQU	9		; Sync/Async Control
M_GCK	EQU	10		; Gated Clock Control
M_MOD	EQU	11		; Mode Select
M_STE	EQU	12		; SSI Transmit Enable
M_SRE	EQU	13		; SSI Receive Enable
M_STIE	EQU	14		; SSI Transmit Interrupt Enable
M_SRIE	EQU	15		; SSI Receive Interrupt Enable

;	SSI Status Register Bit Flags

M_IF	EQU	$2		; Serial Input Flag Mask
M_IF0	EQU	0		; Serial Input Flag 0
M_IF1	EQU	1		; Serial Input Flag 1
M_TFS	EQU	2		; Transmit Frame Sync
M_RFS	EQU	3		; Receive Frame Sync
M_TUE	EQU	4		; Transmitter Underrun Error
M_ROE	EQU	5		; Receiver Overrun Error
M_TDE	EQU	6		; Transmit Data Register Empty
M_RDF	EQU	7		; Receive Data Register Full

;------------------------------------------------------------------------
;
;	EQUATES for Exception Processing
;
;------------------------------------------------------------------------

;	Register Addresses

M_IPR	EQU	$FFFF		; Interrupt Priority Register

;	Interrupt Priority Register Bit Flags

M_IAL	EQU	$7		; IRQA Mode Mask
M_IAL0	EQU	0		; IRQA Mode Interrupt Priority Level (low)
M_IAL1	EQU	1		; IRQA Mode Interrupt Priority Level (high)
M_IAL2	EQU	2		; IRQA Mode Trigger Mode
M_IBL	EQU	$38		; IRQB Mode Mask
M_IBL0	EQU	3		; IRQB Mode Interrupt Priority Level (low)
M_IBL1	EQU	4		; IRQB Mode Interrupt Priority Level (high)
M_IBL2	EQU	5		; IRQB Mode Trigger Mode
M_HPL	EQU	$C00		; Host Interrupt Priority Level Mask
M_HPL0	EQU	10		; Host Interrupt Priority Level Mask (low)
M_HPL1	EQU	11		; Host Interrupt Priority Level Mask (high)
M_SSL	EQU	$3000		; SSI Interrupt Priority Level Mask
M_SSL0	EQU	12		; SSI Interrupt Priority Level Mask (low)
M_SSL1	EQU	13		; SSI Interrupt Priority Level Mask (high)
M_SCL	EQU	$C000		; SCI Interrupt Priority Level Mask
M_SCL0	EQU	14		; SCI Interrupt Priority Level Mask (low)
M_SCL1	EQU	15		; SCI Interrupt Priority Level Mask (high)

;------------------------------------------------------------------------
;
;	EQUATES for Central Processor Registers (56002)
;
;------------------------------------------------------------------------

;	Register Addresses

M_OGDB	EQU	$FFFC		; OnCE Global Data Bus Register
M_PCTL	EQU	$FFFD		; Interrupt Priority Register

;	PLL Control Register Bit Flags

M_MF	EQU	$FFF		; 12-bit multiplication factor mask
M_DF	EQU	$F000		; 4-bit division factor mask
M_XTLD	EQU	16
M_PSTP	EQU	17
M_PEN	EQU	18
M_PCOD	EQU	$180000		; 2-bit clock out disable mask
M_PCOD0	EQU	19
M_PCOD1	EQU	20
M_CSRC	EQU	21
M_CKOS	EQU	22

;	Timer

M_TCSR	EQU	$FFDE
M_TCR	EQU	$FFDF
;
T_TE	EQU	0
T_TIE	EQU	1
T_INV	EQU	2
T_TC0	EQU	3
T_TC1	EQU	4
T_TC2	EQU	5
T_GPIO	EQU	6
T_TS	EQU	7
T_DIR	EQU	8
T_DI	EQU	9
T_DO	EQU	10

	list
; ===============================================================
;
; Peek/Poke masks
;   format:     0maaaa (a=16-bit addr)
;		00aaaa	X:
;		01aaaa	Y:
;		02aaaa	P:
;		04aaaa	R:

PP_MXY	equ	16
PP_MP   equ	17
PP_REG	equ	18

; ===============================================================
;	P:peripherals
;	X:peripherals
; ===============================================================
;
; Flash addresses - 8 16-kbytes sectors
;
;				INVERTED OUT!
;  sec#0	00000-03FFF	SC0=1 SC1=1	P:$C000-$FFFF
;  sec#1	04000-07FFF	SC0=0 SC1=1	P:$C000-$FFFF
;  sec#2	08000-0BFFF	SC0=1 SC1=0	P:$C000-$FFFF
;  sec#3	0C000-0FFFF	SC0=0 SC1=0	P:$C000-$FFFF
;  sec#4	10000-13FFF	SC0=1 SC1=1	X:$C000-$FFFF
;  sec#5	14000-17FFF	SC0=0 SC1=1	X:$C000-$FFFF
;  sec#6	18000-1BFFF	SC0=1 SC1=0	X:$C000-$FFFF
;  sec#7	1C000-1FFFF	SC0=0 SC1=0	X:$C000-$FFFF
;
FLASH	equ	$C000		; C000..FFFF

; ===============================================================
;	Y:peripherals
; ===============================================================
;
QRAM	equ	$C000		; C000..C3FF  bits 0-7
QPAGE0	equ	$C000
QPAGE1	equ	$C100
QPAGE2	equ	$C200
QPAGE3	equ	$C300
QR401	equ	$C330		; data zone for M401 emulation

; Pport test PLD6F
;		CS0	CS1	sel	in latch  out latch
;				read A	read      write
;	00-07	L	H	b1                a->b1
;	08-0F	H	L	b1                  "
;	10-17	L	H	b1	BL+BH       "
;	18-1F	H	L	b1	BL          "
;	20-27	L	H	b2                a->b2
;	28-2F	H	L	b2                  "
;	30-37	L	H	b2	BH          "
;	38-3F	H	L	b2	BL+BH       "
;
; 3s out on B bus: always enabled  if SCO3=0 (INV->external 1)
;		   only when write if SCO3=1 (INV->external 0)

PPORT	equ	$D000
PPORTL	equ	$D000
PPORTH	equ	$D020

; ===============================================================
;
; FPGA MPU401 (23/3/95)
;
;		b23	b22	b21	b20
;  E000	transmit flags PC->DSP
;  E000	R	TF3	TF2	TF1	TF0	(reset=0000)
;  E001	receive flags  DSP->PC
;  E001	R	RF3	RF2	RF1	RF0	(reset=1111)
;  E002 last accessed register (0=data 1=ctrl) for PC writes
;  E002 R	LA3	LA2	LA1	LA0
;
;  E003 R	CAPT	CAPT2	  0	  0	capture strobes
;  E004 R	CD3	CD2	CD1	CD0	capture data nibble L
;  E005 R	CD7	CD6	CD5	CD4	capture data nibble H
;  E006 R	CS0	CA2	CA1	CA0	capture addr nibble L
;  E007 R       CERR    CWR     CFG0    CS1	capture addr nibble H
;
; protocol:
;  PC->DSP
;	PC waits for TF=0
;	PC writes reg(0,1) to QRAM, TF->1
;	DSP waits for TF=1
;	DSP reads reg from QRAM
;	DSP writes 1 to TF, TF->0
;  DSP->PC
;	DSP waits for RF=1
;	DSP writes reg(0) to QRAM, RF->0
;	PC waits for RF=0
;	PC reads reg(0) from QRAM, RF->1
;
FPGA	equ	$E000		; E000..E00F, bits 20-23

F_TF	equ	(FPGA+0)	; 8 read addresses
F_RF	equ	(FPGA+1)
F_AF	equ	(FPGA+2)
F_CW	equ	(FPGA+0)	; 4 write addresses
F_CR	equ	(FPGA+4)	; 4 write addresses

; ===============================================================
;
; UART divisors @8MHz:	4800  = 104
;			9600  = 52
;			19200 = 26
;			31250 = 16 (exact)
;			38400 = 13
;			250k  = 2  (exact)

UART1	equ	$FFC0		; bits 8-15
UART2	equ	$FFC8
UART3	equ	$FFD0
UART4	equ	$FFD8

;----------------------------------------------------------------
;  Receive/Transmit Register (DLAB=0)
;----------------------------------------------------------------
U_RBR	equ	0		; R/O
U_THR	equ	0		; W/O
;----------------------------------------------------------------
; DLL	divider bits 0-7     (DLAB=1)
;----------------------------------------------------------------
U_DLL	equ	0		; if DLAB=1
;----------------------------------------------------------------
; Interrupt Enable Register  (DLAB=0)
;	0  0  0  0	EDSSI	ERLSI	ETBEI	ERBI
;*RESET = 00
;----------------------------------------------------------------
U_IER	equ	1
;----------------------------------------------------------------
; DLM	divider bits 8-15    (DLAB=1)
;----------------------------------------------------------------
U_DLM	equ	1
;----------------------------------------------------------------
;  FIFO Control Register     (DLAB=0)
;	RCVR_Trig[2]  x  x  DMASel XmitRes RcvRes Enable
;*RESET = 00
;----------------------------------------------------------------
U_FCR	equ	2		; W/O
;----------------------------------------------------------------
;  Interrupt Ident Register  (DLAB=0)
; (FIFO)	En[2]  0  0     IRQid[3]  IRQpend
;		 00 = FIFO off/not 16550
;		 01 = FIFO on,16550 compat
;		 10 = FIFO on,old 16550
;		 11 = FIFO on,>=16550A
; (NORM)	0  0   0  0  0  IRQid[2]  IRQpend
;*RESET = 01
;----------------------------------------------------------------
U_IIR	equ	2		; R/O
;----------------------------------------------------------------
;  Line Control Register
;	DLAB  SBRK  STKpty  EPS  PEN  STB  WLSB[2]
;*RESET = 00
;----------------------------------------------------------------
U_LCR	equ	3
;----------------------------------------------------------------
;  Modem Control Register
;     [b15]           [b11]     [b9]    [b8]
;	0  0  *  Loop  XINT  x	RTS	DTR	*=-OUT0(82510)
;     PDWN 0  0  Loop  XINT RES RTS     DTR	(newer 16C550)
;[U1]				SCO1	SCO0
;[U2]				SCO3	SCO2
;[U3]                           SCO5	SCO4
;[U4]                           SCO7	SCO6
;
; ** INVERTED OUTPUTS!! **
;
; SCO0	FLASH A14
; SCO1	FLASH A15
; SCO2	U28-2(AS08)	[0]memP=memX=memY [1]memP=memX!=memY
; SCO3	U41-2(PLD6F)|TP62	Pport out ctrl
; SCO4	jumper JP8 -> U33-22(IOF2O) -> P1 pin 31
;	U47-14 -> J3-21|TP48
; SCO5	jumper JP11-> U33-19(IO2O)  -> P1 pin 51
;	U41-7(PLD6F)
; SCO6	U32-11(inv) -> AD1845 CRES [nc]	** DOUBLE INV **
; SCO7	U32-13(inv) -> AD1848 CPDN	** DOUBLE INV **
;
;*RESET = read 00
;	  pins RTS=DTR=1
;----------------------------------------------------------------
U_MCR	equ	4
U_OR1	equ	UART1+U_MCR
U_SCO0	equ	8		; WARNING - bits 8-15!
U_SCO1	equ	9
U_OR2	equ	UART2+U_MCR
U_SCO2	equ	8
U_SCO3	equ	9
U_OR3	equ	UART3+U_MCR
U_SCO4	equ	8
U_SCO5	equ	9
U_OR4	equ	UART4+U_MCR
U_SCO6	equ	8
U_SCO7	equ	9
;----------------------------------------------------------------
;  Line Status Register
;	FIFOerr  TEMT  THRE  BI  FE  PE  OE  DR
;*RESET = 60
;----------------------------------------------------------------
U_LSR	equ	5
;----------------------------------------------------------------
;  Modem Status Register
;	[b15]	[b14]	[b13]	[b12]	[b11] [b10] [b9]  [b8]
;	DCD	RI	DSR	CTS	dDCD  TERI  dDSR  dCTS
;[U1]	SCI1	SIO23	SCI0    SIO23
;[U2]	SCI3	SIO22	SCI2    SIO22
;[U3]	SIO16	SIO16	SCI4	SCI5
;[U4]	SIO20	SIO20	SCI6	SCI7
;
; SCI0	jumper JP9 <- U33-4(IOF0IB) <- R10k|BAV99 <- P1 pin 6
; SCI1	U41-27(PLD6F)|TP61	tbd
; SCI2	U35-5(rcv)  <- [+]JP6-1 [-]JP6-2
; SCI3	U50-6(inv)  <- JP6-10/pup 10k
; SCI4	U35-11(rcv) <- [+]JP6-3 [-]JP6-4
; SCI5	U50-8(inv)  <- JP6-10/pup 10k
; SCI6	U50-12(inv) <- JP6-7/pup 10k
; SCI7	U50-10(inv) <- JP6-9/pup 10k
;
;*RESET = x0	x=inputs
;----------------------------------------------------------------
U_MSR	equ	6
U_IR1	equ	UART1+U_MSR
U_SCI0	equ	13		; WARNING - bits 8-15!
U_SCI1	equ	15
U_IR2	equ	UART2+U_MSR
U_SCI2	equ	13
U_SCI3	equ	15
U_IR3	equ	UART3+U_MSR
U_SCI4	equ	13
U_SCI5	equ	12
U_IR4	equ	UART4+U_MSR
U_SCI6	equ	13
U_SCI7	equ	12
;----------------------------------------------------------------
;  Scratch Register
;----------------------------------------------------------------
U_SCR	equ	7		; should be 0 at power-up
				; not modified by reset

; ===============================================================
;
AD1848	equ	$FFE0		; bits 8-15

; Special PLD6D version - if there are problems on setup time
; Alt1848	equ	$F0E0
; Clr1848	equ	$FFF0
;
;----------------------------------------------------------------
; Direct registers
;----------------------------------------------------------------
;        b15   b14   b13   b12   b11   b10    b9    b8
; [00]  INIT   MCE   TRD   xxx   IA3   IA2   IA1   IA0
; [01]   ID7   ID6   ID5   ID4   ID3   ID2   ID1   ID0
; [02]  CU/L  CL/R  CRDY  SOUR  PU/L  PU/R  PRDY   INT
; [03]   CD7   CD6   CD5   CD4   CD3   CD2   CD1   CD0
;
;  Direct Register 0 - Index Register		res=$40
;  CDreg		((char *)(CODEC+0))
;  CD0_INIT	  	$80
;  CD0_MCE		$40
;  CD0_TRD		$20
;  CD0_addr	  	$0f		;  mask
;  Direct Register 1 - Indexed Data Register 	res=$00
;  CDdata		((char *)(CODEC+4))
;  Direct Register 2 - Status Register 		res=$cc
;  CDstat		((char *)(CODEC+8))
;  CD2_CUL		$80
;  CD2_CLR		$40
;  CD2_CRDY	  	$20
;  CD2_SOUR	  	$10
;  CD2_PUL		$08
;  CD2_PLR		$04
;  CD2_PRDY	  	$02
;  CD2_INT		$01
;  Direct Register 3 - PIO Data Register 	res=$80
;  CDio		  	((char *)(CODEC+12))
;----------------------------------------------------------------
;
C_IAR	equ	AD1848		; Index Address Register
C_IDR	equ	AD1848+1	; Indexed Data Register
C_SR	equ	AD1848+2	; Status Register
C_PIO	equ	AD1848+3	; PIO Data Register
;
;----------------------------------------------------------------
; Indirect registers
;----------------------------------------------------------------
;        b15   b14   b13   b12   b11   b10    b9    b8
; [00]  LSS1  LSS0  LMGE   xxx  LIG3  LIG2  LIG1  LIG0
; [01]  RSS1  RSS0  RMGE   xxx  RIG3  RIG2  RIG1  RIG0
; [02]  LMX1   xxx   xxx    A4    A3    A2    A1    A0
; [03]  RMX1   xxx   xxx    A4    A3    A2    A1    A0
; [04]  LMX2   xxx   xxx    A4    A3    A2    A1    A0
; [05]  RMX2   xxx   xxx    A4    A3    A2    A1    A0
; [06]   LDM   xxx    A5    A4    A3    A2    A1    A0
; [07]   RDM   xxx    A5    A4    A3    A2    A1    A0
; [08]   xxx   FMT   L/C   S/M  CFS2  CFS1  CFS0   CSS
; [09]  CPIO  PPIO   xxx   xxx  ACAL   SDC   CEN   PEN
; ----------------------------------------------------
; [10]  XCT1  XCT0   xxx   xxx   xxx   xxx   IEN   xxx
;       |     >output mute
;	>FFE4 decoder control
; ----------------------------------------------------
; [11]   COR   PUR   ACI   DRS  ORR1  ORR0  ORL1  ORL0
; [12]   xxx   xxx   xxx   xxx   ID3   ID2   ID1   ID0
; [13]  DMA5  DMA4  DMA3  DMA2  DMA1  DMA0   xxx   DME
; [14]   UB7   UB6   UB5   UB4   UB3   UB2   UB1   UB0
; [15]   LB7   LB6   LB5   LB4   LB3   LB2   LB1   LB0
;
;  Indirect Register 0 - Left Input Control 	res=$00
;  CDX0_LSS1	  	$80
;  CDX0_LSS0	  	$40
;  CDX0_LMGE	  	$20
;  CDX0_LIG	  	$0f
;  Indirect Register 1 - Right Input Control 	res=$00
;  CDX1_RSS1	  	$80
;  CDX1_RSS0	  	$40
;  CDX1_RMGE	  	$20
;  CDX1_RIG	  	$0f
;  Indirect Register 2 - Left Aux#1 Input Control 	res=$80
;  CDX2_LMX1	  	$80
;  CDX2_LX1A	  	$1f
;  Indirect Register 3 - Right Aux#1 Input Control 	res=$80
;  CDX3_RMX1	  	$80
;  CDX3_RX1A	  	$1f
;  Indirect Register 4 - Left Aux#2 Input Control 	res=$80
;  CDX4_LMX2	  	$80
;  CDX4_LX2A	  	$1f
;  Indirect Register 5 - Right Aux#2 Input Control 	res=$80
;  CDX5_RMX2	  	$80
;  CDX5_RX2A	  	$1f
;  Indirect Register 6 - Left DAC Control 	res=1x000000
;  CDX6_LDM	  	$80
;  CDX6_LDA	  	$3f
;  Indirect Register 7 - Right DAC Control 	res=1x000000
;  CDX7_RDM	  	$80
;  CDX7_RDA	  	$3f
;  Indirect Register 8 - Clock/Data Format 	res=x0000000
;  CDX8_FMT	  	$40
;  CDX8_LC		$20
;  CDX8_SM		$10
;  CDX8_CFS	  	$0e
;  CDX8_CSS	  	$01
;  Indirect Register 9 - Interface Config	res=0$x1000
;  CDX9_CPIO	  	$80
;  CDX9_PPIO	  	$40
;  CDX9_ACAL	  	$08
;  CDX9_SDC 	  	$04
;  CDX9_CEN 	  	$02
;  CDX9_PEN 	  	$01
;  Indirect Register 10 - Pin Control		res=0$xxx$
;  CDXA_XCTL1	  	$80
;  CDXA_XCTL0	  	$40
;  CDXA_IEN	  	$02
;  Indirect Register 11 - Test and Init		res=$00
;  CDXB_COR	  	$80
;  CDXB_PUR	  	$40
;  CDXB_ACI	  	$20
;  CDXB_DRS	  	$10
;  CDXB_ORR	  	$0f
;  Indirect Register 12 - Misc Control		res=xxxxRRRR
;  CDXC_ID		$0f
;  Indirect Register 13 - Digital Mix Control	res=00000$0
;  CDXD_DMA	  	$fc
;  CDXD_DME	  	$01
;  Indirect Register 14 - DMA Base Count H	res=$00
;  Indirect Register 15 - DMA Base Count L	res=$00
;----------------------------------------------------------------
;
C_LIC	equ	0		; Left Input Control
C_RIC	equ	1		; Right Input Control
C_LICA1	equ	2		; Left Aux#1 Input Control
C_RICA1	equ	3		; Right Aux#1 Input Control
C_LICA2	equ	4		; Left Aux#2 Input Control
C_RICA2	equ	5		; Right Aux#2 Input Control
C_LOC	equ	6		; Left Output Control
C_ROC	equ	7		; Right Output Control
C_CKDF	equ	8		; Clock/Data Format
C_INTF	equ	9		; Interface Configuration
C_PIN	equ	10		; Pin Control
C_TEST	equ	11		; Test and Initialization
C_MISC	equ	12		; Misc. info
C_DMIX	equ	13		; Digital Mix
C_UBC	equ	14		; Upper Base Count
C_LBC	equ	15		; Lower Base Count
;
; ===============================================================
;
; decoder U49B -	when ADXC1=0 controls TP64,TP65
;			when ADXC1=1 controls AD7869,YM3812
;
AD7869	equ	$FFE4		; CVST/LDAC pulse
;
YM3812	equ	$FFE6		; bits 8-15
;
; WARNING - YM3812 needs a long wait time after register operation
;	for ADRW	12cy@4MHz = 3us
;	for DATW	84cy@4MHz = 21us
;
Y_ADRW	equ	YM3812		; Address Write
Y_DATW	equ	YM3812+1	; Data Write   W/O
Y_STAT	equ	YM3812		; Status Read
				; b5=flg tim#2
				; b6=flg tim#1
				; b7=irq
;
; YM3812 Registers
;
Y_TEST	equ	1		; only D5 defined
Y_TIM1	equ	2		; Tc=80us
Y_TIM2	equ	3		; Tc=320us
Y_TIMC	equ	4		; Timer Control
				; b0=start(1)/stop(0) tim#1
				; b1=start(1)/stop(0) tim#2
				; b5=mask(1) tim#2
				; b6=mask(1) tim#1
				; b7=irq reset(1)
Y_CSMM	equ	8		; CSM Mode/Keyboard Split
Y_AVEK	equ	$20		; 22 REGISTERS $20..$35
				; AM/Vib/Eg-typ/KSR/Multiple
Y_KSTL	equ	$40		; 22 REGISTERS $40..$55
				; Key-Scale level/Total Level
Y_ARDR	equ	$60		; 22 REGISTERS $60..$75
				; Attack Rate/Decay Rate
Y_SLRR	equ	$80		; 22 REGISTERS $80..$95
				; Sustain Level/Release Rate
Y_FNUM	equ	$a0		; 8+8 REGISTERS $a0..$a8,$b0..$b8
Y_KBFN	equ	$b0
Y_DPRH	equ	$bd		; Depth/Rhythm
Y_FBCK	equ	$c0		; 8 REGISTERS $c0..$c8
				; Feedback/Connection
Y_WSEL	equ	$e0		; 22 REGISTERS $e0..$f5
				; Wave Select

; ===============================================================

IRQP	equ	$FFE8		; R/O bits 13-15

PDAK	equ	$FFE8		; W/O

; ===============================================================
;	MACROS
; ===============================================================

MEM_MODE0	macro
	bset	#U_SCO2,Y:<<U_OR2
	endm

MEM_MODE1	macro			; mode 1 is default
	bclr	#U_SCO2,Y:<<U_OR2
	endm

; ===============================================================
	list
	opt	cex,intr,mc,nomd,mex
