
#include <stdio.h>

FILE *fs, *fd=NULL;
int addr;

char nam[32], typ[32];
char dat[16], tim[16];

char hdr2[] = "unsigned char FPGABITS[] =\n{\n";

int header(void)
{
  unsigned short w;

  fseek(fs,0,SEEK_SET);
  w=fgetc(fs)<<8; w|=fgetc(fs);	/* big endian */
  if (w!=0x0009) return 1;
  fseek(fs,w,SEEK_CUR);
  w=fgetc(fs)<<8; w|=fgetc(fs);
  if (w!=0x0001) return 1;

  if (fgetc(fs)!='a') return 1;
  w=fgetc(fs)<<8; w|=fgetc(fs);	/* name len */
  fread(nam,1,w,fs);

  if (fgetc(fs)!='b') return 1;
  w=fgetc(fs)<<8; w|=fgetc(fs);	/* type len */
  fread(typ,1,w,fs);

  if (fgetc(fs)!='c') return 1;
  w=fgetc(fs)<<8; w|=fgetc(fs);	/* date len */
  fread(dat,1,w,fs);

  if (fgetc(fs)!='d') return 1;
  w=fgetc(fs)<<8; w|=fgetc(fs);	/* time len */
  fread(tim,1,w,fs);

  if (fgetc(fs)!='e') return 1;
  return 0;
}

int process(void)
{
  unsigned int i,k;
  int c;

  if (header()) {
    printf("Unrecognized bitstream file\n");
    return 1;
  }
  fd = fopen("fpgabits.i","w");

  fprintf(fd,"/* Automatically generated - do not edit */\n\n");
  fprintf(fd,"char FPGAappl[32]=\"%s\";\n",nam);
  fprintf(fd,"char FPGAtype[32]=\"%s\";\n",typ);
  fprintf(fd,"char FPGAdate[32]=\"%s %s\";\n\n",dat,tim);

  fprintf(fd,"%s",hdr2);
  fread(&k,1,4,fs);
  addr = (k&0xff); k>>=8;
  addr = (addr<<8)|(k&0xff); k>>=8;
  addr = (addr<<8)|(k&0xff); k>>=8;
  addr = (addr<<8)|(k&0xff);
  printf("Config file read is %#x bytes\n", addr);

  for (i=0; i<addr; i++) {
	c=fgetc(fs); if (c==EOF) return 1;
	c &= 0xff;
	if ((i&7)==0) fprintf(fd,"\t0x%02x,",c);
	else if ((i&7)==7) fprintf(fd,"0x%02x,\n",c);
	else fprintf(fd,"0x%02x,",c);
  }
  if ((i&7)!=0) fprintf(fd,"\n");
  fprintf(fd,"};\n\n");
  return 0;
}


int main(int argc, char *argv[])
{
  if (argc<2) return 1;
  fs = fopen(argv[1],"r"); if (fs==NULL) return 1;
  process();
  if (fd) fclose(fd);
  fclose(fs);
  return 0;
}

